'-------------ADMIN ELEVATION------------------
Dim OSList, OS, UAC
UAC = False
If WScript.Arguments.Count >= 1 Then
    If WScript.Arguments.Item(0) = "elevated" Then UAC = True
End If

If Not(UAC) Then
    Set OSList = GetObject("winmgmts:").InstancesOf("Win32_OperatingSystem")
    For Each OS In OSList
        If InStr(1, OS.Caption, "XP") = 0 And InStr(1, OS.Caption, "Server 2003") = 0 Then
            CreateObject("Shell.Application").ShellExecute "wscript.exe", """" & WScript.ScriptFullName & """ elevated" , "", "runas", 1
            WScript.Quit
        End If
    Next
End If
'----------------------------------------------


Dim products, parentAppName, mxiAppCodeName, mxiFileName, packageName
packageName = "SmartMouth_cc.zxp"
mxiFileName = "SmartMouth.mxi"
parentAppName = "Flash/Animate"
mxiAppCodeName = "$flash"
products = Array("Adobe Animate CC 2017", "Adobe Animate CC 2015.2", "Adobe Animate CC 2015", "Adobe Flash CC 2015", "Adobe Flash CC 2014", "Adobe Flash CC")

'-----------------END VARS----------------
packageName = getScriptPath & packageName
'Dim wShell, appShell
'Set wShell = WScript.CreateObject("WScript.Shell")
'  If WScript.Arguments.length = 0 Then
'  Set appShell = CreateObject("Shell.Application")
'  appShell.ShellExecute "wscript.exe", """" & _
'  WScript.ScriptFullName & """" &_
'  " RunAsAdministrator", , "runas", 1
'  End if

run installedApps,packageName, mxiFileName, mxiAppCodeName, parentAppName

Sub run(installedApps,packageName, mxiFileName, mxiAppCodeName, parentAppName)
	Dim result, mxiData, fso, path, exists, root, appFolder, appFolderExists,tfolder, tname, unzipFolder,filesInZip,appShell, abpath, tempFile
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set oShell = WScript.CreateObject("WScript.Shell")
	path = oShell.SpecialFolders("Desktop")
	root = fso.getDrive(fso.GetDriveName(path)).RootFolder
	appFolder = fso.BuildPath(root, "Program Files\Adobe")
	appFolderExists = fso.FolderExists(appFolder)
	If Not appFolderExists Then
		appFolder = fso.BuildPath(oShell.ExpandEnvironmentStrings("%ProgramW6432%"), "\Adobe")
		appFolderExists = fso.FolderExists(appFolder)
	End If
	Set installedApps = getInstalledApps(products, appFolder, parentAppName)
	If installedApps.count = 0 Then
		msgbox "Sorry. No compatible versions of " & parentAppName & " were found.", vbSystemModal
		Exit Sub
	End If
	
	if fso.FileExists(packageName) Then
		'unzip files to temp
		Const TemporaryFolder = 2
		Set tfolder = fso.GetSpecialFolder(TemporaryFolder)
		abpath = fso.GetAbsolutePathName(packageName)		
		tname = fso.GetTempName
		tempFile = fso.BuildPath(tfolder, "temp_installer_ext.zip")
		fso.CopyFile abpath, tempFile, true
		
		unzipFolder = fso.CreateFolder(fso.BuildPath(tfolder, tname))
		Set appShell = CreateObject("Shell.Application")
		Set filesInZip=appShell.NameSpace(fso.GetAbsolutePathName(tempFile)).items
		appShell.NameSpace(unzipFolder).CopyHere(filesInZip)
		On Error Resume Next
			Err.Clear
			Set mxiData = getMXIData(fso.BuildPath(unzipFolder, mxiFileName))
			If Err.Number <> 0 Then
				msgbox "Error while unpacking content.", vbSystemModal
				WScript.Quit()
			Err.Clear
		End If
		On Error Goto 0
		
		result = IEButtons(installedApps, mxiData("name"), mxiData("version"), mxiData("license"))
		if result > -1 Then
			copyFiles unzipFolder, installedApps(result)("path"), mxiData, mxiAppCodeName, parentAppName
			Dim msgStr , usage
			msgStr = "Installation complete. "
			if InStr(mxiData("requiresRestart"), "true") Then
				msgStr = msgStr & vbNewLine & "Please restart " & parentAppName & "."
			End if
			usage = Replace(mxiData("uiAccess"), "<i>","")
			usage = Replace(usage, "</i>","")
			usage = Replace(usage, "<br>","")
			msgStr = msgStr & vbNewLine & "To use " & mxiData("name") & ": "& usage
			msgbox msgStr, vbSystemModal
		End if
		'fso.DeleteFile(fso.GetFile(tempFile))
		fso.DeleteFolder(unzipFolder)
	Else 
		msgbox packageName & " file missing. Make sure the files have been unzipped before running installer.", vbSystemModal
	End if
End Sub

Sub BuildFullPath(ByVal FullPath)
	Set fso = CreateObject("Scripting.FileSystemObject")
	If Not fso.FolderExists(FullPath) Then
	BuildFullPath fso.GetParentFolderName(FullPath)
	fso.CreateFolder FullPath
	End If
	Set fso = Nothing
End Sub

Function copyFiles(unzipFolder, path, mxiData, mxiAppCodeName, parentAppName)
	'loop through files and copy to target directory
	Dim files, fin, copied,fso,count, shell
	Set fso = CreateObject("Scripting.FileSystemObject")
	Set fin = CreateObject("Scripting.Dictionary")
	Set shell = WScript.CreateObject("WScript.Shell")
	Set files = mxiData("files")
	copied = ""
	count = 0
	For Each f in files
		Dim copyFrom, copyTo, loc, fd
		Set fd = files(f)
		copyFrom = fso.BuildPath(unzipFolder, Replace(fd("source"),"/","\"))
		copyTo = Replace( Replace(fd("destination"),"/","\"), mxiAppCodeName, path) & "\"
		if Instr(copyTo, ".gif") Then
			copyTo = fso.getParentFolderName(copyTo) & "\"
		End if
		loc = " |" & copyFrom & copyTo
		if InStr(copied,loc) Then
		Else
			if Not fso.FolderExists(copyTo) Then
				BuildFullPath(copyTo)
			End if
			fso.copyFile copyFrom, copyTo
			copied = copied & loc
			count = count+1
		End if
	Next
	Set fso = Nothing
	Set fin = Nothing
	Set shell = Nothing
	Set shell = Nothing
End Function

Function getFlashConfigFolder(apath, appName)
	Dim fs, objShell, objFolder, objFolderItem, configPath, rPath, testPath
	rPath = apath
	Set fs = CreateObject("Scripting.FileSystemObject")
	Const LOCAL_APPLICATION_DATA = &H1c&
	Set objShell = CreateObject("Shell.Application")
	Set objFolder = objShell.Namespace(LOCAL_APPLICATION_DATA)
	Set objFolderItem = objFolder.Self
	configPath = fs.BuildPath(objFolderItem.Path, "Adobe\" & Replace(appName, "Adobe Flash", "Flash") & "\")
	configPath = Replace(configPath,"Adobe Animate", "Animate")
	if(fs.FolderExists(configPath)) Then
		testPath = fs.BuildPath(configPath, "en_US\Configuration")
		if fs.FolderExists(testPath) Then
			rPath = testPath
		else
			Dim sfs
			Set sfs = fs.getFolder(configPath).SubFolders
			For Each sf in sfs
				if InStr(sf.name, "_") Then
					testPath = fs.BuildPath(configPath, sf.name & "\Configuration")
					if fs.FolderExists(testPath) then
						rPath = testPath
						Exit For
					End if
				End if
			Next
		End if
	End if
	getFlashConfigFolder = rPath
	Set objShell = Nothing
	Set objFolder = Nothing
	Set objFolderItem = Nothing
End Function

Function getInstalledApps(arr, appDir, appName)
	Dim rArr, count, fs
	Set rArr = CreateObject("Scripting.Dictionary")
	Set fs = CreateObject("Scripting.FileSystemObject")
	count = 0
	For Each item in arr
		Dim apath
		apath = fs.BuildPath(appDir, item)
		if fs.FolderExists(apath) Then
			if fs.getFolder(apath).Files.Count > 1 Then
				Dim app
				Set app = CreateObject("Scripting.Dictionary")
				app.add "name", item
				if(InStr(appName, "Flash") Or InStr(appName, "Animate")) Then
					apath = getFlashConfigFolder(apath, item)
				end if
				app.add "path", apath
				rArr.add count, app
				count = count + 1
			End if
		End if
	Next
	if count = 0 Then
		strPath = SelectFolder(appDir, "Please locate your " & appName &" application folder")
		If strPath <> vbNull Then
			Dim cFolder, testPath
			Set cFolder = fs.GetFolder(strPath)
			testPath = fs.BuildPath(cFolder, "Configuration")
			Set re = New RegExp
			re.Pattern  = Replace(appName, "/","|")
			If fs.FolderExists(testPath) And re.Test(testPath) Then
				Dim capp
				Set capp = CreateObject("Scripting.Dictionary")
				capp.add "name", cFolder.name
				capp.add "path", strPath
				rArr.add count, capp
				count = count + 1
			Else
				msgbox "Sorry this directory could not be verified. Please contact support.", vbSystemModal
			End If
		End If
	End if
	Set getInstalledApps = rArr
End Function

Function getMXIData(path)
	Dim count, fileDict, rData, rr
	Set xmlDoc = CreateObject( "Microsoft.XMLDOM" )
	Set rData = CreateObject("Scripting.Dictionary")
	xmlDoc.Async = False
	xmlDoc.SetProperty "SelectionLanguage", "XPath"
	if xmlDoc.load(path) Then
		rData.Add "name", xmlDoc.selectSingleNode("//macromedia-extension/@name").text
		rData.Add "version", xmlDoc.selectSingleNode("//macromedia-extension/@version").text
		Set rr = xmlDoc.selectSingleNode("//macromedia-extension/@requires-restart")
		if rr is Nothing Then
			rData.Add "requiresRestart", "false"
		Else
			rData.Add "requiresRestart", rr.text
		End if
		rData.Add "license", xmlDoc.selectSingleNode("//macromedia-extension/license-agreement").text
		rData.Add "uiAccess", xmlDoc.selectSingleNode("//macromedia-extension/ui-access").text
		count = 0
		Set fileDict = CreateObject("Scripting.Dictionary")
		For Each fileNode In xmlDoc.selectNodes("//macromedia-extension/files/file")
			Dim fileObj
			Set fileObj = CreateObject("Scripting.Dictionary")
			fileObj.Add "source", fileNode.getAttribute("source")
			fileObj.Add "destination", fileNode.getAttribute("destination")
			fileDict.Add count, fileObj
			count = count + 1
		Next
		rData.Add "files", fileDict
		Set getMXIData = rData
    Else
		getMXIData = Nothing
       'WScript.Echo path, xmlDoc.parseError.reason, "Src:", xmlDoc.parseError.srcText
    End if

end Function

Function getScriptPath()
	Set objShell = CreateObject("Wscript.Shell")
	strPath = Wscript.ScriptFullName
	Set objFSO = CreateObject("Scripting.FileSystemObject")
	Set objFile = objFSO.GetFile(strPath)
	getScriptPath = objFSO.GetParentFolderName(objFile) & "\"
end Function

Function IEButtons(choices, sTitle, versionStr, licenseStr )    ' This function uses Internet Explorer to create a dialog.
    Dim ie, iErrorNum, codeStr, wShell, selected
    Set ie = CreateObject( "InternetExplorer.Application" )    ' Create an IE object
	Set wShell = WScript.CreateObject("Wscript.Shell")
    ' specify some of the IE window's settings
    ie.Navigate "about:blank"
    sTitle= sTitle
	'& String( 1000, "_" ) 'Note: the String( 80,".") is to push "Internet Explorer" string off the window
    ie.Document.title = sTitle
	ie.Fullscreen 	= True
	ie.TheaterMode 	= True
	ie.TheaterMode 	= False
    ie.MenuBar        = False
    ie.ToolBar        = False
    ie.AddressBar     = false
    ie.Resizable      = False
    ie.StatusBar      = False
    ie.Width          = 800 
    ie.Height         = 640
	ie.Left = 200
	ie.Top = 200
    Do While ie.Busy    ' Wait till IE is ready
        WScript.Sleep 200
    Loop
	codeStr = "<style>body{background-color:#dedede;}h3,p{margin-top:4px;margin-bottom:0;width:100%;}</style><h3>Install " & sTitle _
		& " <span style=""float:right;"">v" & versionStr & "</span></h3>" _
		& "<p>Please choose a version:</p><form action="""" onsubmit=""event.preventDefault(); return false"">" _
		& "<div><input type=""hidden"" id=""Result"" name=""Result"" value=""0"">" _
		& "<select id=""Products"" name=""Products"" style=""width:100%;""id=""versionSelected"" required=""required"" multiple=""multiple"">"
    selected = "selected=""selected"" "
	For Each x In choices
		Dim aname
		aname = choices(x)("name")
		codeStr = codeStr & "<option value=""" & aname & """ " & selected & ">"& aname &"</option>"
		selected = ""
	Next
	codeStr = codeStr & "</select><p>Please read and accept the agreement below:</p>" _
		& "<div style=""background-color:white;width:100%;height:160px;overflow:scroll;overflow-x:hidden;border:1px solid black;padding:2px;"">" & licenseStr & "</div>" _
		& "<div style=""float:right; margin-top:10px;"">" _
        & "<input style=""margin-right:10px;""type=""button"" id=""CancelButton"" value=""Cancel"" onClick=""javascript:document.getElementById('Result').value=-1;"">" _
		& "<input type=""button"" id=""installButton"" value=""Accept &amp; Install &gt;"" " _
		& "onClick=""javascript:document.getElementById('Result').value=document.getElementById('Products').selectedIndex+1;""></div></div></form>"
		
    ie.Document.body.innerHTML = codeStr    ' Insert the HTML code to prompt for user input
    ie.Document.body.style.overflow = "auto"    ' Hide the scrollbars
    ie.Visible = True ' Make the window visible
	
	wShell.AppActivate sTitle
	'oWSHShell.sendkeys "%{enter}" ' Restore if minimized
	
	' Set focus on Install button
	ie.Document.focus()
    ie.Document.all.installButton.focus

    'CAVEAT: If user click red X to close IE window instead of click cancel, an error will occur.
    '        Error trapping Is Not doable For some reason
    On Error Resume Next
    Do While ie.Document.all.Result.value = 0
        WScript.Sleep 200
        iErrorNum=Err.Number
        If iErrorNum <> 0 Then    'user clicked red X (or alt-F4) to close IE window
            IEButtons = 0
            ie.Quit
            Set ie = Nothing
            Exit Function
        End if
    Loop
    On Error Goto 0

    ie.Visible = False 
	IEButtons = CInt(ie.Document.all.Result.value)-1 ' Read the user input from the dialog window
    ie.Quit ' Close and release the object
    Set ie = Nothing
End Function

Function SelectFolder( myStartFolder, promptStr)
' This function opens a "Select Folder" dialog and will
' return the fully qualified path of the selected folder
'
' Argument:
'     myStartFolder    [string]    the root folder where you can start browsing;
'                                  if an empty string is used, browsing starts
'                                  on the local computer
'
' Returns:
' A string containing the fully qualified path of the selected folder
'
' Written by Rob van der Woude
' http://www.robvanderwoude.com

    ' Standard housekeeping
    Dim objFolder, objItem, objShell
    
    ' Custom error handling
    On Error Resume Next
    SelectFolder = vbNull

    ' Create a dialog object
    Set objShell  = CreateObject( "Shell.Application" )
    Set objFolder = objShell.BrowseForFolder( 0, promptStr, 0, myStartFolder )

    ' Return the path of the selected folder
    If IsObject( objfolder ) Then SelectFolder = objFolder.Self.Path

    ' Standard housekeeping
    Set objFolder = Nothing
    Set objshell  = Nothing
    On Error Goto 0
End Function